#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <alloca.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <inttypes.h>
#include <string.h>
#include <stdlib.h>

#include "tools.h"

#define EXZESS_VENDOR ((uint16_t)0x0815)
#define EXZESS_DEVICE ((uint16_t)0x4711)

#define XILINX_VENDOR ((uint16_t)0x10ee)
#define XILINX_DEVICE ((uint16_t)0x0007)

int main(int argc, char **argv)
{
	set_log_level(LL_TRACE);
	char *dev_dir = find_pci_device_dir(EXZESS_VENDOR, EXZESS_DEVICE);
	if (! dev_dir) {
		dev_dir = find_pci_device_dir(XILINX_VENDOR, XILINX_DEVICE);
	}
	exit_if (NULL == dev_dir, "no suitable device found\n");
	log_msg(LL_NOTICE, "found device at %s\n", dev_dir);

	perror_if(-1 == chdir(dev_dir), "could not cd to %s", dev_dir);
	int resfd = open("resource0", O_RDWR);
	perror_if(-1 == resfd, "could not open resource0 file: ");

	uint32_t * volatile bar0 = mmap(NULL, 1024, PROT_READ | PROT_WRITE, MAP_SHARED, resfd, 0);
	perror_if(MAP_FAILED == bar0, "mmap of BAR 0 failed\n");

	printf("%s", hexdump((char*)bar0, 0x80));

	exit(EXIT_SUCCESS);
}
